/*
 * This is a part of hserver project.                                                
 * You can freely redistribute this source code under BSD license
 */
/* $Id: check_hslist.c 80 2003-09-28 22:58:07Z pynoos $ */

/* FILE DESCRIPTION -----------------------------------------------------------------*/

/*! \author
 *  \brief
 * 
 */

/* FORWARD DECLARATION --------------------------------------------------------------*/
#include "hserverstd.h"
#include "hslist.h"

/* LOCAL DATA -----------------------------------------------------------------------*/

/* FUNCTION DEFINITION --------------------------------------------------------------*/

/*! \brief This is sample function
 *
 * This sample function is from someone's brains.
 * It works very well in such a complicated environment even with
 * no line in those body.
 *
 * \param arg1 result will be stored in this non-const pointing buffer
 * \param arg2 the arg1's buffer length
 * \param arg3 arg3 is non-editable string!
 * \return 0 : command was done and no error was found.
 *         -1: command was failed to cry..
 * \see See also
 */

void test1()
{
	int       i;
	hslist_t  hl;
	hslist_t  iter;
	hslist_init(&hl);

	for (i = 0; i < 10000; i++)
	{
		int      *p = malloc(sizeof(int));
		*p = i;
		hslist_push_front(&hl, p);
	}

	i = 10000;
	HSLIST_FOR_EACH(iter, hl)
	{
		i--;
		assert(i == *(int *) HSLIST_DATA(iter));
	}
	hslist_destroy(&hl, TRUE);
	assert(IS_HSLIST_END(hl));
}

int main()
{
	puts("Check hslist start.");
	test1();
	puts("Check hslist done... Success");
	return 0;
}

#ifndef NDEBUG
static char id[] __UNUSED__ = "$Id: check_hslist.c 80 2003-09-28 22:58:07Z pynoos $";
#endif
/*
 * History
   $Log$
   Revision 1.2  2003/09/28 22:58:07  pynoos
   Added hslist test message

   Revision 1.1  2003/09/28 22:53:03  pynoos
   Newadded

 */
