/*
 * This is a part of hserver project.                                                
 * You can freely redistribute this source code under BSD license
 */
/* $Id: hslist.c 83 2003-10-07 08:51:02Z pynoos $ */

/* FILE DESCRIPTION -----------------------------------------------------------------*/

/*! \author Hojin Choi
 *  \brief generic signle linked list
 * 
 */

/* FORWARD DECLARATION --------------------------------------------------------------*/
#include "hserverstd.h"
#include "hslist.h"

/* LOCAL DATA -----------------------------------------------------------------------*/

/* FUNCTION DEFINITION --------------------------------------------------------------*/

hslist_t *hslist_init(hslist_t * list)
{
	*list = (hslist_t) 0;
	return list;
}

BOOL hslist_push_front(hslist_t * list, void *data)
{
	hslist_t  newlist = (hslist_t) malloc(sizeof(struct _hslist_t));
	if (!newlist)
	{
		return FALSE;
	}
	newlist->next = *list;
	newlist->data = data;
	*list = newlist;
	return TRUE;
}

void hslist_destroy(hslist_t * list, BOOL clear_data)
{
	hslist_t  iter;
	hslist_t  front;
	if (!list ||!*list ||IS_HSLIST_END(*list))
	{
		return;
	}

	front = *list;
	hslist_init(list);

	for (iter = front; !IS_HSLIST_END(iter); iter = front)
	{
		front = iter->next;
		if (clear_data)
		{
			free(iter->data);
		}
		free(iter);
	}
}

#ifndef NDEBUG
static char id[] __UNUSED__ = "$Id: hslist.c 83 2003-10-07 08:51:02Z pynoos $";
#endif
/*
 * History
   $Log$
   Revision 1.3  2003/10/07 08:51:02  pynoos
   First draft of BLOCKED-TYPE series

   Revision 1.2  2003/09/28 22:51:57  pynoos
   Remove end mark object, add test code

   Revision 1.1  2003/09/28 03:55:17  pynoos
   Add first draft

   Revision 1.1  2003/09/23 23:05:16  pynoos
   New added list

 */
