/*
 * This is a part of hserver project.                                                
 * You can freely redistribute this source code under BSD license
 */
/* $Id: hslist.h 83 2003-10-07 08:51:02Z pynoos $ */

#ifndef HSLIST_H
#define HSLIST_H

/* FILE DESCRIPTION -----------------------------------------------------------------*/

/*! \author Hojin Choi
 *  \brief generic linked list
 * 
 */

/* DECLARATION ----------------------------------------------------------------------*/
#include "hserverstd.h"

typedef struct _hslist_t
{
	struct _hslist_t *next;
	void     *data;
}
         *hslist_t;

#define IS_HSLIST_END(i) ((i)==0)
#define HSLIST_FOR_EACH( i, list ) \
	for( (i)=(list); !IS_HSLIST_END(i); (i)=(i)->next )
#define HSLIST_DATA(i) ((i)->data)
#define HSLIST_EMPTY(l) ((l)==0)

/* EXPORTED VARIABLES ---------------------------------------------------------------*/

/* EXPORTED FUNCTIONS ---------------------------------------------------------------*/
hslist_t *hslist_init(hslist_t * list);
BOOL      hslist_push_front(hslist_t * list, void *data);
void      hslist_destroy(hslist_t * list, BOOL clear_data);

/* INLINE FUNCTIONS -----------------------------------------------------------------*/

#endif /*HSLIST_H */
/*
 * History
   $Log$
   Revision 1.4  2003/10/07 08:51:02  pynoos
   First draft of BLOCKED-TYPE series

   Revision 1.3  2003/09/28 22:51:57  pynoos
   Remove end mark object, add test code

   Revision 1.2  2003/09/28 04:59:13  pynoos
   reincluding armor

   Revision 1.1  2003/09/28 03:55:17  pynoos
   Add first draft

   Revision 1.1  2003/09/23 23:05:16  pynoos
   New added list

 */
