/*
 * This is a part of hserver project.                                                
 * You can freely redistribute this source code under BSD license
 */
/* $Id: hshttpd.c 88 2003-10-07 15:16:57Z pynoos $ */

/* FILE DESCRIPTION -----------------------------------------------------------------*/

/*! \author Hojin Choi
 *  \brief Test webserver
 * 
 */

/* FORWARD DECLARATION --------------------------------------------------------------*/
#include "hserver.h"

/* LOCAL DATA -----------------------------------------------------------------------*/

/* FUNCTION DEFINITION --------------------------------------------------------------*/

int webserver_core(int fd, void *arg)
{
	const char *msg = "200 OK\r\nContent-type: text/plain\r\n\r\nTest page\r\n";
	char      req[LARGE_BUFFER_SIZE];

	arg = arg;

	if (0 < recv(fd, req, sizeof req, 0))
	{
		send(fd, msg, strlen(msg), 0);
	}
	return 0;
}

int hshttpd(hsocket * hsock)
{
	webserver_core(hsock->fd, 0);
	return 0;
}

/*! \brief 
 * \see See also
 */

int main(int argc, char *argv[])
{
#if defined TEST_HS_FORK
	hs_init(HSINIT_FORK);
#elif defined TEST_HS_THREAD
	hs_init(HSINIT_THREAD);
#elif defined TEST_HS_PREFORK
	hs_init(HSINIT_PREFORK);
	hs_cntl(HS_PREFORKS, 20);
#elif defined TEST_HS_NONBLOCKIO
	hs_init(HSINIT_NONBLOCKIO);
#endif
	hs_task_install(hsocket_server("0.0.0.0", 8080), hshttpd);
	hs_task_install(hsocket_server("0.0.0.0", 8088), hshttpd);
	hs_run();
	hs_destroy();
	return 0;
}

#ifndef NDEBUG
static char id[] __UNUSED__ = "$Id: hshttpd.c 88 2003-10-07 15:16:57Z pynoos $";
#endif
/*
 * History
   $Log$
   Revision 1.5  2003/10/07 15:16:57  pynoos
   Adjust preforked processes.

   Revision 1.4  2003/10/07 08:51:56  pynoos
   Change to support new initialization.

   Revision 1.3  2003/09/28 05:24:18  pynoos
   Bug fix

   Revision 1.2  2003/09/28 03:54:29  pynoos
   First draft

   Revision 1.1  2003/09/27 14:46:22  pynoos
   Sample httpd draft.

 */
/* vim: path+=../src
 */
