/*
 * This is a part of hserver project.                                                
 * You can freely redistribute this source code under BSD license
 */
/* $Id: hslist.c 57 2003-09-23 23:05:16Z pynoos $ */

/* FILE DESCRIPTION -----------------------------------------------------------------*/

/*! \author Hojin Choi
 *  \brief generic signle linked list
 * 
 */

/* FORWARD DECLARATION --------------------------------------------------------------*/
#include "hserverstd.h"
#include "hslist.h"

/* LOCAL DATA -----------------------------------------------------------------------*/

/* FUNCTION DEFINITION --------------------------------------------------------------*/

struct _hslist_t s_list_end;

hslist_t *hslist_init(hslist_t * list)
{
	*list = &s_list_end;
}

BOOL hslist_push_front(hslist_t * list, void *data)
{
	hslist_t  newlist = (hslist_t) malloc(sizeof(struct _hslist_t));
	if (!newlist)
	{
		return FALSE;
	}
	newlist->next = *list;
	newlist->data = data;
	*list = newlist;
	return TRUE;
}

#ifndef NDEBUG
static char id[] __UNUSED__ = "$Id: hslist.c 57 2003-09-23 23:05:16Z pynoos $";
#endif
/*
 * History
   $Log$
   Revision 1.1  2003/09/23 23:05:16  pynoos
   New added list

 */
