/*
 * This is a part of hserver project.                                                
 * You can freely redistribute this source code under BSD license
 */
/* $Id: hslist.h 57 2003-09-23 23:05:16Z pynoos $ */

/* FILE DESCRIPTION -----------------------------------------------------------------*/

/*! \author Hojin Choi
 *  \brief generic linked list
 * 
 */

/* DECLARATION ----------------------------------------------------------------------*/
#include "hserverstd.h"

typedef struct _hslist_t
{
	struct _hslist_t *next;
	void     *data;
}
         *hslist_t;

extern struct _hslist_t s_list_end;
#define IS_HSLIST_END(i) ((i)==(&s_list_end))
#define HSLIST_FOR_EACH( i, list ) \
	for( (i)=(list); !IS_HSLIST_END(i); (i)=(i)->next )

/* EXPORTED VARIABLES ---------------------------------------------------------------*/

/* EXPORTED FUNCTIONS ---------------------------------------------------------------*/
hslist_t *hslist_init(hslist_t * list);
BOOL      hslist_push_front(hslist_t * list, void *data);

/* INLINE FUNCTIONS -----------------------------------------------------------------*/

/*
 * History
   $Log$
   Revision 1.1  2003/09/23 23:05:16  pynoos
   New added list

 */
